{ 030125a2b.pas                                                             }
{ 2003-01-25 programmeerimisvistluse algajate 2. lesande lahendus         }
{    OMISTAMISKEEL                                                          }
{ Indrek Jentson                                                            }
{ Testitud: FPC 1.0.6/Win32, TPC 7.0                                        }

var
  source, result : text;
  commands : integer;   { tulemus }
  lines : integer;      { ttlemata ridade arv }
  line : String[50];    { ttlemisel olev rida }
  position : integer;   { viimane loetud positsioon reas }
  ch : char;            { viimane loetud trk }

const
  lf : char = chr(10);  { --> see on reavahetuse kood }
  ef : char = chr(0);   { --> sellega thistame faili lppu }

{ defineerime meile vajaminevate smbolite jaoks uue tbi }
type
  symbol = (error, empty, name, assignment, number, semicolon);

{ Protseduur jrgmise trgi eraldamiseks.
}
procedure getCh;
begin
  if position < 0 then { kui 'position' on negatiivne }
  begin
    if lines > 0 then  { ja veel on ttlemata ridasid }
    begin
      readln(source, line); { siis loeme failist uue rea }
      dec(lines);
      position := 0;
    end;
  end;
  if position >= 0 then
  begin
    inc(position);
    if position > length(line) then
      begin
      position := -1; { rida sai otsa, laseme lugeda uue rea }
      ch := lf;
      end
    else
      ch := line[position]; { vtame jrgmise trgi }
  end
  else
    ch := ef; { sisendandmed on otsas }
end;

{ Funktsioon jrgmise smboli leidmiseks.
}
function getSym : symbol;
begin
  { jtame vahele thikud ja reavahetused }
  while (ch = ' ') or (ch = lf) do getCh;
  { kas on tegemist kommentaariga? }
  if ch = '/' then
    begin
      getCh;
      if ch = '*' then { ongi kommentaar }
        begin
          { jtame kommentaari vahele, otsime lputunnust }
          getCh;
          repeat
            while (ch <> '*') and (ch <> ef) do getCh;
            if ch = '*' then getCh;
          until (ch = '/') or (ch = ef);
          if ch = '/' then { lputunnus leitud }
            begin
              getCh;
{ Parameetriteta funktsiooni rekursiivse vljakutse sntaks on              }
{ FreePascalis ja Turbo Pascalis erinev                                     }
{$ifdef fpc} 
              getSym := getSym() { ksime jrgmist smbolit }
{$else}
              getSym := getSym { ksime jrgmist smbolit }
{$endif}
            end
          else
            getSym := error
        end
      else
        getSym := error;
    end
  { kas tegemist on omistamisega? }
  else if ch = ':' then
    begin
      getCh;
      if ch = '=' then { ongi omistamise operaator }
        begin
          getCh;
          getSym := assignment
        end
      else
        getSym := error;
    end
  else if ch in ['a'..'z'] then { muutuja nimi }
    begin
      getCh;
      while ch in ['a'..'z'] do getCh;
      getSym := name
    end
  else if ch in ['1'..'9'] then { number }
    begin
      getCh;
      while ch in ['0'..'9'] do getCh;
      getSym := number
    end
  else if ch = ';' then { semikoolon }
    begin
      getCh;
      getSym := semicolon
    end
  else
    getSym := empty;
end;

{ Funktsioon meile vajaliku kujuga lause leidmiseks.
}
function findCommand : boolean;
{ Otsime lauset kujul: name ':=' number ';' }
var
  sym : symbol;
begin
  sym := getSym;
  if sym <> name then
  begin
    findCommand := false;
    exit;
  end;
  sym := getSym;
  if sym <> assignment then
  begin
    findCommand := false;
    exit;
  end;
  sym := getSym;
  if sym <> number then
  begin
    findCommand := false;
    exit;
  end;
  sym := getSym;
  if sym <> semicolon then
  begin
    findCommand := false;
    exit;
  end;
  findCommand := true;
end;

begin
  { avame faili programmi tekstiga }
  assign(source, 'omist.sis');
  reset(source);
  readln(source, lines);
  position := -1;
  ch := ' ';
  { loeme kokku omistamislaused }
  commands := 0;
  while findCommand do
    inc(commands);
  close(source);
  { vljstame tulemuse }
  assign(result, 'omist.val');
  rewrite(result);
  writeln(result, commands);
  close(result);
end.
