{ 030125a3b.pas                                                             }
{ 2003-01-25 programmeerimisvistluse algajate 3. lesande lahendus         }
{    KASSAAPARAAT                                                           }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'KASSA.SIS';
   valf = 'KASSA.VAL';

{ leiab tehingu vrtuse (koos mrgiga) }
function tehing (s : string) : longint;
var k, z : longint; u, i : integer;
begin
   i := pos('*', s);                           { leiame korrutamise asukoha }
   if i = 0 then begin                             { kui korrutamist polnud }
      k := 1;                                        { rahathtede arv on 1 }
      val(s, z, u);              { rahathe (mrgiga) vrtus on terve rida }
   end else begin                                     { kui korrutamine oli }
      val(copy(s, 1, i - 1), k, u);                     { (mrgiga) kordaja }
      val(copy(s, i + 1, length(s) - i), z, u);          { rahathe vrtus }
   end;
   tehing := k * z;
end;

var
   f : text;                                           { sisend/vljundfail }
   x : longint;                                         { jooksev kassajk }
   n : integer;                                             { tehingute arv }
   i : integer;
   s : string;

begin
   assign(f, sisf); reset(f);                { avame sisendfaili lugemiseks }
   readln(f, x);                                     { loeme kassa algseisu }
   readln(f, n);                                     { loeme tehingute arvu }
   for i := 1 to n do begin                             { ttleme tehingud }
      readln(f, s);                              { loeme tehingu kirjelduse }
      x := x + tehing(s);                         { lisame tehingu summasse }
   end;                                           { vtame jrgmise tehingu }
   close(f);                                          { sulgeme sisendfaili }

   assign(f, valf); rewrite(f);          { avame vljundfaili kirjutamiseks }
   writeln(f, x);                                     { vljastame tulemuse }
   close(f);                                         { sulgeme vljundfaili }
end.
