{ 030125e3a.pas                                                             }
{ 2003-01-25 programmeerimisvistluse edasijudnute 3. lesande lahendus    }
{    KASSAAPARAAT                                                           }
{ Meelis Karp                                                               }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

{
Ko~ik sisendist tulnud arvud teisendatakse 9-ndsu"steemist
ku"mnendsu"steemi, arvutatakse ku"mnendsu"steemis.
Va"ljastamisel teisendatakse tulemus taas ku"mnendsu"steemist
u"heksandsu"steemi.
}

Const Sisendfail='KASSA.SIS';
      Valjundfail='KASSA.VAL';

Var KassaJaak   : LongInt;
    Ifile, Ofile: TEXT;
    Rida        : String;
    i           : Integer;
    N,Z,K       : Integer;
    Mark        : Char;
    OnKorrutamine: Integer;
    Arv         : String;
    Code        : Word;

{
U"heksandsu"steemi teisendamine ku"mnendsu"steemi.
Funktsioon vo~tab sisendisse u"heksandsu"steemis arvu stringina
ning va"ljastab ku"mnendsu"steemis arvu }
Function YheksaKymneks(S: String): Integer;
Var l:Integer;
    i:Integer;
    Arv:Integer;
    Number: Integer;
begin
 Arv:=0;
 l:=Length(S);
 for i:=1 to l do begin
  Number:=Ord(S[i])-Ord('0');
  Arv:=Arv*9+Number;
 end;
 YheksaKymneks:=Arv;
end;

{
Ku"mnendsu"steemis arvu teisendamine u"heksandsu"steemi.
Funktsioon vo~tab sisendisse ku"mnendsu"steemis arvu ja
va"ljastab u"heksandsu"steemis arvu (sellega pa"rast enam tehteid
teha ei tohi, kuna Pascal arvutab ku"mnendsu"steemis). }
Function KymmeYheksaks(Arv:LongInt): LongInt;
Var Tulem: LongInt;
    Number: Integer;
    Jark: LongInt;
begin
 Jark:=1;
 Tulem:=0;
 while Arv>0 do begin
  Number:=Arv mod 9;
  Tulem:=Tulem+Jark*Number;
  Jark:=Jark*10;
  Arv:=Arv div 9;
 end;
 KymmeYheksaks:=Tulem;
end;

BEGIN
 Writeln('Programmeerimisolu"mpiaadi piirkonnavoor 12.01.2003');
 Writeln('Edasijo~udnute ru"hm, 3. u"lesanne.');
 Writeln('Na"idislahendus');
 Assign(Ifile,Sisendfail);
 Assign(Ofile,Valjundfail);
 Reset(Ifile);
 Readln(Ifile,Rida);
 KassaJaak:=YheksaKymneks(Rida);
 Readln(Ifile,Rida);
 N:=YheksaKymneks(Rida);
 for i:=1 to N do begin
  Readln(Ifile,Rida);
  Mark:=Rida[1];
  OnKorrutamine:=pos('*',Rida);
  if OnKorrutamine=0 then begin   {kui korrutamisma"rki pole}
   Arv:=copy(Rida,2,Length(Rida)-1);
   Z:=YheksaKymneks(Arv);
   K:=1;
  end
  else begin                      {kui korrutusma"rk leidub}
   Arv:=copy(Rida,2,OnKorrutamine-2);
   K:=YheksaKymneks(Arv);
   Arv:=copy(Rida,OnKorrutamine+1,Length(Rida)-OnKorrutamine);
   Z:=YheksaKymneks(Arv);
  end;
  case Mark of
   '+': KassaJaak:=KassaJaak+LongInt(K)*LongInt(Z);
   '-': KassaJaak:=KassaJaak-LongInt(K)*LongInt(Z);
  end;
 end;
 Close(Ifile);
 Rewrite(Ofile);
 Writeln(Ofile,KymmeYheksaks(KassaJaak));
 Close(Ofile);
END.
