{ 030125e3b.pas                                                             }
{ 2003-01-25 programmeerimisvistluse edasijudnute 3. lesande lahendus    }
{    KASSAAPARAAT                                                           }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'KASSA.SIS';
   valf = 'KASSA.VAL';

{ leiab (mrgita) 9-ssteemi arvu vrtuse }
function val9 (s : string) : longint;
const num : array ['0'..'8'] of integer = (0, 1, 2, 3, 4, 5, 6, 7, 8);
var k : longint; i : integer;
begin
   k := 0;
   for i := 1 to length(s) do
      k := 9 * k + num[s[i]];
   val9 := k;
end;

{ leiab (mrgita) arvu esituse 9-ssteemis }
function str9 (k : longint) : string;
const num : array [0..8] of char = ('0', '1', '2', '3', '4', '5', '6', '7', '8');
var s : string;
begin
   s := '';
   while k > 0 do begin
      s := num[k mod 9] + s;
      k := k div 9;
   end;
   if s = '' then
      s := '0';
   str9 := s;
end;

{ leiab tehingu vrtuse (koos mrgiga) }
function tehing (s : string) : longint;
var k, z : longint; i : integer;
begin
   i := pos('*', s);
   if i = 0 then begin
      k := 1;
      z := val9(copy(s, 2, length(s) - 1));
   end else begin
      k := val9(copy(s, 2, i - 2));
      z := val9(copy(s, i + 1, length(s) - i));
   end;
   if s[1] = '+' then
      tehing := k * z
   else
      tehing := -k * z;
end;

var
   f : text;                                           { sisend/vljundfail }
   x : longint;                                         { jooksev kassajk }
   n : integer;                                             { tehingute arv }
   i : integer;
   s : string;

begin
   assign(f, sisf); reset(f);                { avame sisendfaili lugemiseks }
   readln(f, s); x := val9(s);                       { loeme kassa algseisu }
   readln(f, s); n := val9(s);                       { loeme tehingute arvu }
   for i := 1 to n do begin                             { ttleme tehingud }
      readln(f, s);                              { loeme tehingu kirjelduse }
      x := x + tehing(s);                         { lisame tehingu summasse }
   end;                                            { vtame jrgmise klahvi }
   close(f);                                          { sulgeme sisendfaili }

   assign(f, valf); rewrite(f);          { avame vljundfaili kirjutamiseks }
   writeln(f, str9(x));                               { vljastame tulemuse }
   close(f);                                         { sulgeme vljundfaili }
end.
