PROGRAM kontroll;

USES
 SysUtils;

TYPE
 t_maatriks = ARRAY [1..10, 1..10] OF Char;

VAR
 sfail, vfail : Text;

 k, l : Integer;
 N : integer;
 maatr_1, maatr_2 : t_maatriks;

 on_90, on_180, on_270 : Boolean;
 on_V, on_H, on_D : Boolean;

 on_jah : Boolean;

 rida1, rida2, tekst : String;
 loeti_r2 : Boolean;

 vastus_oige : Boolean;
 sai_loetud : Boolean;


BEGIN
 IF ParamCount<2 THEN BEGIN
  WriteLn ('Sntaks on: ',ParamStr (0),' sisendfail valjundfail');
  Halt (1);
 END;

 {----- andmete lugemine -----}
 WriteLn ('Sisendandmete lugemine...');

 Assign (sfail, ParamStr (1));
 Reset (sfail);

 ReadLn (sfail, N);

 {esimene maatriks}
 FOR k := 1 TO N DO BEGIN
  FOR l := 1 TO N DO
   Read (sfail, maatr_1[k, l]);
  ReadLn (sfail);
 END;

 {teine maatriks}
 FOR k := 1 TO N DO BEGIN
  FOR l := 1 TO N DO
   Read (sfail, maatr_2[k, l]);
  ReadLn (sfail);
 END;

 Close (sfail);


 {----- omaduste kontrollimine -----}
 on_90 := TRUE;
 on_180 := TRUE;
 on_270 := TRUE;
 on_V := TRUE;
 on_H := TRUE;
 on_D := TRUE;

 FOR k := 1 TO N DO
  FOR l := 1 TO N DO BEGIN
   IF maatr_1[k, l] <> maatr_2 [l,         (N+1) - k] THEN on_90 := FALSE;
   IF maatr_1[k, l] <> maatr_2 [(N+1) - k, (N+1) - l] THEN on_180 := FALSE;
   IF maatr_1[k, l] <> maatr_2 [(N+1) - l, k]         THEN on_270 := FALSE;
   IF maatr_1[k, l] <> maatr_2 [k,         (N+1) - l] THEN on_V := FALSE;
   IF maatr_1[k, l] <> maatr_2 [(N+1) - k, l]         THEN on_H := FALSE;
   IF maatr_1[k, l] <> maatr_2 [l,         k]         THEN on_D := FALSE;
  END;

 on_jah := on_90 OR on_180 OR on_270 OR on_V OR on_H OR on_D;


 {----- vljundi lugemine -----}
 WriteLn ('Vljundi lugemine...');
 WriteLn;

 Assign (sfail, ParamStr (2));
 Reset (sfail);

 Readln (sfail, rida1);

 {vastuse kontroll}
 sai_loetud := TRUE;
 loeti_r2 := FALSE;

 IF UpperCase (Trim (rida1)) = 'EI' THEN BEGIN
  vastus_oige := NOT on_jah;
 END ELSE BEGIN
  ReadLn (sfail, rida2);
  loeti_r2 := TRUE;
  tekst := UpperCase (Trim (rida2));

  IF      tekst = '90'  THEN vastus_oige := on_90
  ELSE IF tekst = '180' THEN vastus_oige := on_180
  ELSE IF tekst = '270' THEN vastus_oige := on_270
  ELSE IF tekst = 'V'   THEN vastus_oige := on_V
  ELSE IF tekst = 'H'   THEN vastus_oige := on_H
  ELSE IF tekst = 'D'   THEN vastus_oige := on_D
  ELSE sai_loetud := FALSE;
 END;

 {tulemuse kirjutamine}
 IF sai_loetud THEN BEGIN
  IF vastus_oige THEN WriteLn ('OK')
  ELSE WriteLn ('Vastus vale');

  WriteLn;

  {kujundusega seotu}
  IF UpperCase (Trim (rida1)) <> rida1 THEN
   WriteLn ('Vljundrida #1: ''',rida1,'''');
  IF     loeti_r2
     AND (UpperCase (Trim (rida2)) <> rida2) THEN
   WriteLn ('Vljundrida #2: ''',rida2,'''');
  IF NOT Eof (sfail) THEN BEGIN
   WriteLn ('Vljundfail pole loppenud');
  END;
 END ELSE BEGIN
  WriteLn ('Vljundformaat vale:');
  Writeln ('''',rida1,'''');
  IF loeti_r2 THEN Writeln ('''',rida2,'''');
  WriteLn;
 END;


 Close (sfail);
END.
