/**
 * Programmeerimisolmpiaadi piirkondlik voor.
 * Algajate rhm.
 * 1. lesanne - Telefoninumber
 * Nidislahendus
 * Autor: Leopold Parts, leopold@ut.ee
 * Testitud: GCC 2.95.2/MinGW32
 */

#include <fstream.h>
#include <string.h> // strlen

int map[26]; // siin on iga the kohta kirjas, millisele numbrile ta kuulub
			 // 'a' kuuluvus on kohas 0, 'b' kuuluvus on kohas 1, ... 'z' kuuluvus on kohas 25
char sona[22];  // sna, mille numbrit on vaja leida
char vastus[22];// vastus

void readInput();
void output();
void stringToNumber(char text[]);

int main(){

	readInput();
	output();

	return 0;
}


/**
 * Loeb sisendfailist sisendi
 */
void readInput(){

	int N = 0;      // klahvide arv
	char klahv[30]; // klahvi kirjeldav s6ne

	// avame faili
	ifstream in("TELNR.SIS");

	// loeme klahvide arvu
	in >> N;

	// iga klahvi jaoks
	for(int i = 0; i < N; ++i){
		//loeme sisse teda kirjeldava s6ne
		in >> klahv;
		int number = klahv[0] - '0'; // klahvi number
		for(int j = 1; j < strlen(klahv); ++j){
			char taht = klahv[j];  // igale numbrile jrgnevale thele
			map[taht - 'a'] = number; // vastab see number
		}
	}

	// loeme sna
	in >> sona;

	// sulgeme faili
	in.close();
}


/**
 * Salvestab tulemuse vljundfaili
 */
void output(){

	// avame faili
	ofstream out("TELNR.VAL");

	stringToNumber(sona);
	// vljastame vastuse ja kige lppu reavahetuse
	out << vastus << endl;

	// fail kinni
	out.close();
}


/**
 * Moodustab snest talle vastava telefoninumbri
 */
void stringToNumber(char text[]){

	int i;

	// iga sna the jaoks
	for(i = 0; i < strlen(text); ++i){
		// vljastame talle vastava numbri
		// text[i] - 'a' annab the indeksi thestikus ('a' -> 0, 'b' -> 1 jne
		// '0' + map(text[i] - 'a') annab vastava numbri ascii koodi
		vastus[i] = '0' + (map[text[i] - 'a']);
	}

	vastus[i] = '\0'; // stringi lpu this
}
