{ 030125a4b.pas                                                             }
{ 2003-01-25 programmeerimisvistluse algajate 4. lesande lahendus         }
{    MAATRKISID                                                             }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'MAATR.SIS';
   valf = 'MAATR.VAL';
   maxn = 10;

type
   maatr = array [1..maxn, 1..maxn] of char;

{ loeb failist n*n maatriksi }
procedure loe_maatr (var f : text; var m : maatr; n : integer);
var i, j : integer;
begin
   for i := 1 to n do begin
      for j := 1 to n do
         read(f, m[i, j]);
      readln(f);
   end;
end;

{ kontrollib, kas m1 pratud 90 kraadi on m2 }
function on90 (var m1, m2 : maatr; n : integer) : boolean;
var i, j : integer;
begin
   on90 := true;
   for i := 1 to n do
      for j := 1 to n do
         if m1[i, j] <> m2[j, n - i + 1] then
            on90 := false;
end;

{ kontrollib, kas m1 pratud 180 kraadi on m2 }
function on180 (var m1, m2 : maatr; n : integer) : boolean;
var i, j : integer;
begin
   on180 := true;
   for i := 1 to n do
      for j := 1 to n do
         if m1[i, j] <> m2[n - i + 1, n - j + 1] then
            on180 := false;
end;

{ kontrollib, kas m1 pratud 270 kraadi on m2 }
function on270 (var m1, m2 : maatr; n : integer) : boolean;
var i, j : integer;
begin
   on270 := true;
   for i := 1 to n do
      for j := 1 to n do
         if m1[i, j] <> m2[n - j + 1, i] then
            on270 := false;
end;

{ kontrollib, kas m1 peegeldatud vertikaalteljest on m2 }
function onV (var m1, m2 : maatr; n : integer) : boolean;
var i, j : integer;
begin
   onV := true;
   for i := 1 to n do
      for j := 1 to n do
         if m1[i, j] <> m2[i, n - j + 1] then
            onV := false;
end;

{ kontrollib, kas m1 peegeldatud horisontaalteljest on m2 }
function onH (var m1, m2 : maatr; n : integer) : boolean;
var i, j : integer;
begin
   onH := true;
   for i := 1 to n do
      for j := 1 to n do
         if m1[i, j] <> m2[n - i + 1, j] then
            onH := false;
end;

{ kontrollib, kas m1 peegeldatud peadiagonaalist on m2 }
function onD (var m1, m2 : maatr; n : integer) : boolean;
var i, j : integer;
begin
   onD := true;
   for i := 1 to n do
      for j := 1 to n do
         if m1[i, j] <> m2[j, i] then
            onD := false;
end;

var
   f : text;                                           { sisend/vljundfail }
   n : integer;                                        { maatriksite suurus }
   m1, m2 : maatr;                                             { maatriksid }

begin
   assign(f, sisf); reset(f);
   readln(f, n);
   loe_maatr(f, m1, n);
   loe_maatr(f, m2, n);
   close(f);

   assign(f, valf); rewrite(f);
   if on90(m1, m2, n) then begin
      writeln(f, 'JAH');
      writeln(f, '90');
   end else if on180(m1, m2, n) then begin
      writeln(f, 'JAH');
      writeln(f, '180');
   end else if on270(m1, m2, n) then begin
      writeln(f, 'JAH');
      writeln(f, '270');
   end else if onV(m1, m2, n) then begin
      writeln(f, 'JAH');
      writeln(f, 'V');
   end else if onH(m1, m2, n) then begin
      writeln(f, 'JAH');
      writeln(f, 'H');
   end else if onD(m1, m2, n) then begin
      writeln(f, 'JAH');
      writeln(f, 'D');
   end else
      writeln(f, 'EI');
   close(f);
end.
