/**
 * Programmeerimisolmpiaadi piirkondlik voor.
 * Edasijudnute rhm.
 * 1. lesanne - Telefoninumber
 * Nidislahendus
 * Autor: Leopold Parts, leopold@ut.ee
 * Testitud: GCC 2.95.2/MinGW32
 */

#include <fstream.h>
#include <string.h> // strlen

int map[26]; // siin on iga the kohta kirjas, millisele numbrile ta kuulub
						 // 'a' kuuluvus on kohas 0, 'b' kuuluvus on kohas 1, ... 'z' kuuluvus on kohas 25
char number[22];  // number, mille snu on vaja leida
char vastus[22];  // number, mille saame snastiku sna vastavalt reeglitele numbriks muutes

void readInput();
void stringToNumber(char text[]);

int main(){

	readInput();

	return 0;
}


/**
 * Loeb sisendfailist sisendi
 */
void readInput(){

	int N = 0;      // klahvide arv
	int M = 0;		  // snastiku snade arv
	char klahv[30]; // klahvi kirjeldav s6ne
	char tekst[22]; // snastiku ks sna

	// avame sisendfaili
	ifstream in("TELNR.SIS");
	//avame vljundfaili
	ofstream out("TELNR.VAL");

	// loeme klahvide arvu
	in >> N;

	// iga klahvi jaoks
	for(int i = 0; i < N; ++i){
		//loeme sisse teda kirjeldava s6ne
		in >> klahv;
		int num = klahv[0] - '0'; // klahvi number
		for(int j = 1; j < strlen(klahv); ++j){
			char taht = klahv[j];  // igale numbrile jrgnevale thele
			map[taht - 'a'] = num; // vastab see number
		}
	}

	// loeme antud numbri
	in >> number;

	// loeme snastiku snade arvu
	in >> M;

	for(int i = 0; i < M; ++i){
		// loeme jrgmise snastiku sna
		in >> tekst;
		// leiame temale vastava numbri
		stringToNumber(tekst);

		// kui vaadeldav number ja saadud number htivad, vljastame selle sna
		if(!strcmp(vastus, number)){
			out << tekst << endl;
		}

	}

	// sulgeme failid
	in.close();
	out.close();
}



/**
 * Moodustab snest talle vastava telefoninumbri
 */
void stringToNumber(char text[]){

	int i;

	// iga sna the jaoks
	for(i = 0; i < strlen(text); ++i){
		// vljastame talle vastava numbri
		// text[i] - 'a' annab the indeksi thestikus ('a' -> 0, 'b' -> 1 jne
		// '0' + map(text[i] - 'a') annab vastava numbri ascii koodi
		vastus[i] = '0' + (map[text[i] - 'a']);
	}

	vastus[i] = '\0'; // stringi lpu this
}
