{ 030125e4b.pas                                                             }
{ 2003-01-25 programmeerimisolmpiaadi edasijudnute 4. lesande lahendus   }
{    MAATRIKSID                                                             }
{ Kirsto Tammeoja                                                           }
{ Testitud: FPC 1.0.6/GO32V2, TPC 6.0                                       }

CONST
 sis_fail = 'MAATR.SIS';
 val_fail = 'MAATR.VAL';

TYPE
 t_maatriks = ARRAY [1..10, 1..10] OF Char;

VAR
 sfail, vfail : Text;

 k, l : Integer;
 N : integer;
 maatr_1, maatr_2 : t_maatriks;

 on_90, on_180, on_270, on_360 : Boolean;
 on_V, on_H, on_D, on_A : Boolean; {A - abidiagonaali suhtes peegeldatud}


PROCEDURE kirjuta_jah (tee : String);
BEGIN
 WriteLn (vfail, 'JAH');
 WriteLn (vfail, Length (tee));
 WriteLn (vfail, tee);
END; {kirjuta_jah}


PROCEDURE kirjuta_ei;
BEGIN
 WriteLn (vfail, 'EI');
END; {kirjuta_ei}


BEGIN
 {----- andmete lugemine -----}
 Assign (sfail, sis_fail);
 Reset (sfail);

 ReadLn (sfail, N);

 {esimene maatriks}
 FOR k := 1 TO N DO BEGIN
  FOR l := 1 TO N DO
   Read (sfail, maatr_1[k, l]);
  ReadLn (sfail);
 END;

 {teine maatriks}
 FOR k := 1 TO N DO BEGIN
  FOR l := 1 TO N DO
   Read (sfail, maatr_2[k, l]);
  ReadLn (sfail);
 END;

 Close (sfail);


 {----- omaduste kontrollimine -----}
 on_90 := TRUE;
 on_180 := TRUE;
 on_270 := TRUE;
 on_360 := TRUE;
 on_V := TRUE;
 on_H := TRUE;
 on_D := TRUE;
 on_A := TRUE;

 FOR k := 1 TO N DO
  FOR l := 1 TO N DO BEGIN
   IF maatr_1[k, l] <> maatr_2 [l,         (N+1) - k] THEN on_90 := FALSE;
   IF maatr_1[k, l] <> maatr_2 [(N+1) - k, (N+1) - l] THEN on_180 := FALSE;
   IF maatr_1[k, l] <> maatr_2 [(N+1) - l, k]         THEN on_270 := FALSE;
   IF maatr_1[k, l] <> maatr_2 [k,         l]         THEN on_360 := FALSE;
   IF maatr_1[k, l] <> maatr_2 [k,         (N+1) - l] THEN on_V := FALSE;
   IF maatr_1[k, l] <> maatr_2 [(N+1) - k, l]         THEN on_H := FALSE;
   IF maatr_1[k, l] <> maatr_2 [l,         k]         THEN on_D := FALSE;
   IF maatr_1[k, l] <> maatr_2 [(N+1) - l, (N+1) - k] THEN on_A := FALSE;
  END;


 {----- vastuse kirjutamine -----}
 Assign (vfail, val_fail);
 Rewrite (vfail);

 IF      on_360 THEN kirjuta_jah ('')
 ELSE IF on_90  THEN kirjuta_jah ('P')
 ELSE IF on_V   THEN kirjuta_jah ('V')
 ELSE IF on_180 THEN kirjuta_jah ('PP')
 ELSE IF on_D   THEN kirjuta_jah ('PV')
 ELSE IF on_A   THEN kirjuta_jah ('VP')
 ELSE IF on_270 THEN kirjuta_jah ('PPP')
 ELSE IF on_H   THEN kirjuta_jah ('VPP')
 ELSE kirjuta_ei;

 Close (vfail);
END.
